package com.bursie.harvester.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;

/**
 * An utility class to use when an internet resource should be queried.
 */
public class InternetQuery {

    /**
     * A utility method for querying an internet resource for search results of some kind.
     *
     * @param urlBase An url on which the query should be appended
     * @param query   A search string for which to query the internet resource
     * @return A result string. The format depends on the type of query sent.
     * @throws IOException If something went wrong
     */
    public String getQueryResult(String urlBase, String query) throws IOException {
        // get util
        String encodedQuery = URLEncoder.encode(query, "ISO-8859-1");
        String urlAddress = urlBase + encodedQuery;
        URL url = new URL(urlAddress);
        URLConnection connection = url.openConnection();
        connection.addRequestProperty("Referer", "http://www.bursie.com/index.html");

        // get result from util
        String line;
        StringBuilder builder = new StringBuilder();
        BufferedReader reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));
        while ((line = reader.readLine()) != null) {
            builder.append(line);
        }
        return builder.toString();
    }
}
